--
--  Copyright (C) 2011, 2015 secunet Security Networks AG
--  Copyright (C) 2011, 2015 Reto Buerki <reet@codelabs.ch>
--  Copyright (C) 2011, 2015 Adrian-Ken Rueegsegger <ken@codelabs.ch>
--
--  This program is free software; you can redistribute it and/or modify it
--  under the terms of the GNU General Public License as published by the
--  Free Software Foundation; either version 2 of the License, or (at your
--  option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
--
--  This program is distributed in the hope that it will be useful, but
--  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
--  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
--  for more details.
--

with Ada.Command_Line;

with DHCP.Termination;
with DHCP.Notify;
with DHCP.Observers;

package body DHCP_Observers_Tests is

   use Ahven;
   use DHCP;

   -------------------------------------------------------------------------

   procedure Initialize (T : in out Testcase)
   is
   begin
      T.Set_Name (Name => "Tests for observers");
      T.Add_Test_Routine
        (Routine => One_Shot_Observer'Access,
         Name    => "One-shot observer");
   end Initialize;

   -------------------------------------------------------------------------

   procedure One_Shot_Observer
   is
      use Ada.Command_Line;
   begin
      Observers.One_Shot_Mode (R => Notify.Bound);
      Assert (Condition => Termination.Wait = Success,
              Message   => "Exit code not Success");

      Observers.One_Shot_Mode (R => Notify.Timeout);
      Assert (Condition => Termination.Wait = Failure,
              Message   => "Exit code not Failure");
   end One_Shot_Observer;

end DHCP_Observers_Tests;
